<template>
  <div class="modal">
    <slot></slot>
    <h2 class="h2 modal__title">{{ postId }}</h2>
    <form class="modal__left">
      <input type="text" class="modal__input el-input" :value="postTitle" />
      <textarea
        name=""
        id=""
        cols="30"
        :value="postText"
        class="modal__textarea el-textarea"
      ></textarea>
      <input type="submit" @click.prevent="" value="Сохранить" />
    </form>
    <section class="modal__right">
      <article
        v-for="comment in commentsPostFilter"
        :key="comment.id"
        class="comments"
      >
        <h6 class="comments__title">{{ comment.name }}</h6>
        <a
          :href="`mailto:${comment.email}`"
          title="Написать на электронную почту"
          class="comments__email"
          >{{ comment.email }}</a
        >
        <p class="comments__text">{{ comment.body }}</p>
      </article>
    </section>
  </div>
</template>

<script setup>
import { ref, onMounted, computed } from "vue";

const props = defineProps({
  postId: {
    type: Number,
    required: true,
    default: 1,
  },
  postTitle: {
    type: String,
    required: true,
    default: "",
  },
  postText: {
    type: String,
    required: true,
    default: "",
  },
});

// получение данных о комментах
const responseUrl = "https://jsonplaceholder.typicode.com/comments";
let responseData = ref([]);

(async () => {
  const response = await fetch(responseUrl);
  responseData.value = await response.json();
})();

const commentsPostFilter = computed(() =>
  responseData.value.filter((item) => props.postId === item.postId)
);
</script>

<style lang="less">
.modal {
  box-sizing: border-box;
  display: grid;
  grid-template-areas:
    "a a a"
    "b c c";
  position: fixed;
  top: 0;
  background: #fff;
  height: 100vh;
  width: 100vw;
  padding: 50px;
}
.modal__close {
  position: absolute;
  right: 50px;
  top: 50px;
}
.modal__title {
  text-align: center;
  grid-area: a;
}
.modal__input {
  display: block;
  margin-bottom: 10px;
  width: 100%;
}
.modal__textarea {
  width: 100%;
  height: 100%;
  margin-bottom: 10px;
}
.modal__left {
  grid-area: b;
  display: flex;
  flex-direction: column;
}
.modal__right {
  grid-area: c;
  padding-left: 50px;
  overflow-y: scroll;
}
</style>
